<?php
@session_start();

require_once('config.php');
require_once('smarty/libs/Smarty.class.php');
require_once('lang.php');
require_once('sendmail.php');

define_syslog_variables();
openlog('MySPAM', LOG_PID | LOG_PERROR, LOG_LOCAL0);

$smarty = new Smarty();
$smarty->template_dir = '';
$smarty->compile_dir = 'templates_c/';
$smarty->config_dir = '';
$smarty->cache_dir = '';
$smarty->left_delimiter = '<{';
$smarty->right_delimiter = '}>';

if (!isset($argc, $argv)) {
    $argc = $_SERVER['argc'];
    $argv = $_SERVER['argv'];
}

if ($argc == 2 && $argv[1] == 'send_notify') {
    require_once('notify.php');
    SendNotify();
    closelog();
    exit;
}

if ($argc == 2 && $argv[1] == 'save_spam') {
    require_once('save.php');
    $rc = SaveSPAM();
    closelog();
    $ret = ($rc == 0) ? 0 : EX_TEMPFAIL;
    exit($ret);
}

if ($argc == 2 && $argv[1] == 'test_save_spam') {
    require_once('save.php');
    $debug = true;
    $test_mode = true;
    $rc = SaveSPAM();
    closelog();
    $ret = ($rc == 0) ? 0 : EX_TEMPFAIL;
    exit($ret);
}

unset($username);
unset($password);
if (isset($_SESSION['username'])) $username = $_SESSION['username'];

if (!isset($username) || empty($username)) {
    $username = isset($_POST['username']) ? $_POST['username'] : '';
    $password = isset($_POST['password']) ? $_POST['password'] : '';
    $errmsg = '';

    if (isset($username) && !empty($username)) {
        $errmsg = $lang['ERROR_LOGIN'];
        if (isset($password) && !empty($password)) {
            // check login
            if (CheckAuthPOP($username, $password)) {
                // show main page
                $_SESSION['username'] = $username;
                require_once('list.php');
                ShowList(0);
                closelog();
                exit;
            }
        }
    }
    require_once('login.php');
    ShowLogin($username, $errmsg);
    closelog();
    exit;
}

if (isset($_POST['logout'])) {
    session_unset();
    session_destroy();
    require_once('login.php');
    ShowLogin('', '');
    closelog();
    exit;
}

$start = isset($_GET['start']) ? $_GET['start'] : 0;
if (!isset($start) || empty($start))
    $start = 0;

$name = '';
$search_type = '';
$search_val = '';
$val = '';
if (!isset($_POST['search_all'])) {
    $val = isset($_GET['val']) ? $_GET['val'] : '';
    if (isset($_POST['search']))
        $val = '';
    else if ($val !== '')
        list ($name, $search_type, $search_val) = split (",", $val);
    if ($search_val == '')
        $search_val = isset($_POST['search_val']) ? $_POST['search_val'] : '';
    if ($search_type == '')
        $search_type = isset($_POST['search_type']) ? $_POST['search_type'] : '';
}

if (isset($_SESSION['in_filter'])) {
    if ($_POST['back_list']) {
        unset($_SESSION['in_filter']);
        unset($_SESSION['in_rule']);
        require_once('list.php');
        ShowList(0);
        closelog();
        exit;
    }
    require_once('filter.php');
    ShowFilter($start);
    closelog();
    exit;
}

if (isset($_POST['filter'])) {
    $_SESSION['in_filter'] = 1;
    require_once('filter.php');
    ShowFilter(0);
    closelog();
    exit;
}

$msg = '';
if (isset($_POST['resend'])) {
    // resend email
    $aID = $_POST['email_id_list'];
    $list = '';
    if (isset($aID) && !empty($aID)) {
        foreach ($aID as $id) {
            if ($list == '')
                $list = $id;
            else
                $list .= ",$id";
        }
    }
    if ($list != '') {
        $conn = @mysql_connect($dbhost, $dbuser, $dbpass);
        if ($conn) {
            @mysql_select_db($dbname, $conn);
            @mysql_query("SET NAMES '".DB_ENCODING."'", $conn);

            $cnt = 0;
            $ok = 0;
            $sql = "select email_text, email_id
                    from myspam_email
                    where email_user = '".@mysql_escape_string($username)."'
                    and email_id in ($list)";
            $result = @mysql_query($sql, $conn);
            if ($result) {
                while ($row = @mysql_fetch_row($result)) {
                    $cnt++;
                    $email_id = $row[1];
                    if (send_mail($username, gzuncompress(base64_decode($row[0])))) {
                        $ok++;
                        syslog(LOG_INFO, "resend $email_id for $username");
                    }
                    else
                        syslog(LOG_INFO, "failed to resend $email_id for $username");
                }
                @mysql_free_result($result);
                $msg = sprintf($lang['RESEND_MESSAGE'], $ok, $cnt);
            }
            else
                $msg = $lang['DB_ERROR'];
            @mysql_close($conn);
        }
        else
            $msg = $lang['DB_ERROR'];
    }
}
else if (isset($_POST['notspam'])) {
    // notspam email
    $aID = $_POST['email_id_list'];
    $list = '';
    if (isset($aID) && !empty($aID)) {
        foreach ($aID as $id) {
            if ($list == '')
                $list = $id;
            else
                $list .= ",$id";
        }
    }
    if ($list != '') {
        $conn = @mysql_connect($dbhost, $dbuser, $dbpass);
        if ($conn) {
            @mysql_select_db($dbname, $conn);
            @mysql_query("SET NAMES '".DB_ENCODING."'", $conn);

            $cnt = 0;
            $ok = 0;
            $sql = "select email_text, email_id
                    from myspam_email
                    where email_user = '".@mysql_escape_string($username)."'
                    and email_id in ($list)";
            $result = @mysql_query($sql, $conn);
            if ($result) {
                while ($row = @mysql_fetch_row($result)) {
                    $cnt++;
                    $email_id = $row[1];
                    $fname = $notspam_path.$username.'_'.$email_id.'.msg';
                    $fp = @fopen($fname, "wb");
                    if ($fp) {
                        fwrite($fp,gzuncompress(base64_decode($row[0])));
                        fclose($fp);
                        $ok++;
                        syslog(LOG_INFO, "save notspam $email_id for $username");
                    }
                    else
                        syslog(LOG_INFO, "failed to save notspam $email_id for $username");
                }
                @mysql_free_result($result);
                $msg = sprintf($lang['NOTSPAM_MESSAGE'], $ok, $cnt);
            }
            else
                $msg = $lang['DB_ERROR'];
            @mysql_close($conn);
        }
        else
            $msg = $lang['DB_ERROR'];
    }
}
else if (isset($_POST['delete'])) {
    // delete email
    // resend email
    $aID = $_POST['email_id_list'];
    $list = '';
    if (isset($aID) && !empty($aID)) {
        foreach ($aID as $id) {
            if ($list == '')
                $list = $id;
            else
                $list .= ",$id";
        }
    }
    if ($list != '') {
        $conn = @mysql_connect($dbhost, $dbuser, $dbpass);
        if ($conn) {
            @mysql_select_db($dbname, $conn);
            @mysql_query("SET NAMES '".DB_ENCODING."'", $conn);

            $sql = "delete
                    from myspam_email
                    where email_user = '".@mysql_escape_string($username)."'
                    and email_id in ($list)";
            $result = @mysql_query($sql, $conn);
            if ($result) {
                $cnt = @mysql_affected_rows($conn);
                syslog(LOG_INFO, "delete $cnt email for $username from list ($list)");
                $msg = sprintf($lang['DELETE_MESSAGE'], $cnt);
            }
            else
                $msg = $lang['DB_ERROR'];
            @mysql_close($conn);
        }
        else
            $msg = $lang['DB_ERROR'];
    }
}

require_once('list.php');
ShowList($start, $search_type, $search_val, $msg);
closelog();
exit;

function CheckAuthPOP($username, $password)
{
    global $pop3_server, $pop3_port;
    $fp = @fsockopen($pop3_server, $pop3_port);
    if (!$fp) return 0;
    $buf = fgets($fp);
    if ($buf[0] != '+') {
        fclose($fp);
        return 0;
    }
    fputs($fp, "USER $username\n");
    $buf = fgets($fp);
    if ($buf[0] != '+') {
        fclose($fp);
        return 0;
    }
    fputs($fp, "PASS $password\n");
    $buf = fgets($fp);
    fclose($fp);
    if ($buf[0] != '+')
        return 0;
    return 1;
}

?>
