<?php

if (!defined('IN_MYSPAM')) {
    global $spam_url;
    header('Location: '.$spam_url);
    exit;
}

function writelog($str)
{
    global $test_mode, $debug;

    if ($test_mode) {
        echo $str."\n";
        $fp = fopen('/tmp/debug.log', 'at');
        if ($fp) {
            fputs($fp, $str."\n");
            fclose($fp);
        }
    }
    else
        syslog($debug ? LOG_DEBUG : LOG_INFO, $str);
    return;
}

function SaveSPAM()
{
    global $dbhost, $dbuser, $dbpass, $dbname;
    global $debug, $test_mode, $test_user;

    if ($test_mode) error_reporting(E_ALL);

    if (!isset($_SERVER['LOGNAME'])) {
        if (!$test_mode) {
            writelog('no LOGNAME!');
            return 1;
        }
        $user = $tesr_user;
    }
    else {
        if ($test_mode)
            $user = $test_user;
        else
            $user = $_SERVER['LOGNAME'];
    }
    if (!isset($_SERVER['SIZE']))
        $size = 0;
    else
        $size = $_SERVER['SIZE'];
    if ($size == '') $size = 0;

    if ($debug) writelog("save spam for $user, size $size");

    if ($test_mode) {
        $fname = 'test.msg';
        if (!is_file($fname))
            $fname = '/tmp/test.msg';
    }
    else
        $fname = 'php://stdin';

    $fp = fopen($fname, 'rb');
    if ($fp == 0) {
        writelog("Can't open $fname");
        return 1;
    }

    $from = '';
    $subject = '';
    $body = 0;
    $content = '';
    $txt_encoding = '';
    $last_header = '';
    $aHeader = array();
    $cnt = 0;
    $size_cnt = 0;
    $first = true;
    while (feof($fp) == 0) {
        $buf = fgets($fp, 4096);
        if ($size == 0) $size_cnt += strlen($buf);
        if ($first) {
            $first = false;
            if (strncasecmp('From ', $buf, 5) == 0) continue;
        }
        if ($body) {
            $content .= $buf;
            continue;
        }
        if (strncasecmp('Delivered-To:', $buf, 13) == 0) continue;
        $content .= $buf;
        if ($buf === "\n") {
            $body = 1;
            continue;
        }
        $space = trim(substr($buf, 0, 1));
        if ($space === '') {
            if ($cnt > 0) {
                $x = $cnt -1;
                if (strcasecmp($header, 'Subject') == 0)
                    $subject .= ' '.trim($buf);
                else if (strcasecmp($header, 'From') == 0)
                    $from .= ' '.trim($buf);
                else if (strcasecmp($header, 'Content-Type') == 0) {
                    $p = stristr($buf, 'charset=');
                    if ($p)
                        $txt_encoding = trim(substr($p, 8), " \"\r\n\t\0\x0B");
                }
                $aHeader[$x]['value'] .= ' '.trim($buf);
            }
            continue;
        }
        list($header, $header_text) = split(':', $buf, 2);
        $header = trim($header);
        $header_text = trim($header_text);
        $aHeader[$cnt++] = array('name' => $header, 'value' => $header_text);
        if (strcasecmp($header, 'Subject') == 0)
            $subject = $header_text;
        else if (strcasecmp($header, 'From') == 0)
            $from = $header_text;
        else if (strcasecmp($header, 'Content-Type') == 0) {
            $p = stristr($header_text, 'charset=');
            if ($p)
                $txt_encoding = trim(substr($p, 8), " \"\r\n\t\0\x0B");
        }
    }
    fclose($fp);
    if ($size == 0) $size = $size_cnt;

    if ($debug) writelog("txt_encoding is $txt_encoding");
    if (strcasecmp($txt_encoding, 'iso-8859-1') == 0) {
        $txt_encoding = '';
        if ($debug) writelog("remove encoding for iso-8859-1");
    }

    $from = preg_replace("(\r\n|\n|\r)", "", $from);
    $subject = preg_replace("(\r\n|\n|\r)", "", $subject);

    if ($debug) writelog("from is $from");
    if ($debug) writelog("subject is $subject");

    $decode_subject = find_decode_str($subject, $txt_encoding);
    $decode_from = find_decode_str($from, $txt_encoding);

    if ($debug) writelog("after decode from is $decode_from");
    if ($debug) writelog("after decode subject is $decode_subject");

    for ($i = 0; $i < $cnt; $i++)
        $aHeader[$i]['value'] = find_decode_str($aHeader[$i]['value'], $txt_encoding);

    if ($test_mode) writelog(var_export($aHeader, true));

    if ($debug) writelog("checking filter for $user");
    require_once('checkfilter.php');
    $result = CheckFilter($user, $aHeader);
    if ($result) {
        // allow this email
        if (send_mail($user, $content)) {
            writelog("send match filter mail for $user");
            $conn = @mysql_connect($dbhost, $dbuser, $dbpass);
            if (!$conn) {
                writelog("Can't connect database! Assume no any filter");
                return 0;
            }
            @mysql_select_db($dbname, $conn);
            @mysql_query("SET NAMES '".DB_ENCODING."'", $conn);

            $sHeader = '';
            foreach ($aHeader as $sbj => $str) {
                $sHeader .= "$sbj: $str\n";
            }

            $sql = "insert into myspam_filter_email (
                filter_email_time,
                filter_email_user,
                filter_email_from,
                filter_email_subject,
                filter_email_text
            ) values (
                now(),
                '".@mysql_escape_string($user)."',
                '".@mysql_escape_string($decode_from)."',
                '".@mysql_escape_string($decode_subject)."',
                '".@mysql_escape_string($sHeader)."'
            )";

            if (!@mysql_query($sql, $conn)) {
                writelog("failed to insert data to mysql");
            }
            else {
                $id = @mysql_insert_id($conn);
                writelog("insert filter record for $user with id $id");
            }
            @mysql_close($conn);
            return 0;
        }
        writelog("failed to send match filter mail for $user");
        return 1;
    }

    if ($debug) writelog("try to compress and encode mail for $user");
    $gzdata = base64_encode(gzcompress($content, 9));

    if ($debug) writelog("try to save data to database for $user");
    $conn = @mysql_connect($dbhost, $dbuser, $dbpass);
    if (!$conn) {
        writelog("Can't connect database!");
        return 1;
    }
    @mysql_select_db($dbname, $conn);
    @mysql_query("SET NAMES '".DB_ENCODING."'", $conn);

    $sql = "insert into myspam_email (
        email_time,
        email_user,
        email_notify,
        email_from,
        email_subject,
        email_size,
        email_text
    ) values (
        now(),
        '".@mysql_escape_string($user)."',
        0,
        '".@mysql_escape_string($decode_from)."',
        '".@mysql_escape_string($decode_subject)."',
        $size,
        '".@mysql_escape_string($gzdata)."'
    )";

    if (!@mysql_query($sql, $conn)) {
        $rc = 1;
        writelog("failed to insert data to mysql");
        writelog("mysql code:".@mysql_errno($conn));
        writelog("mysql error:".@mysql_error($conn));
    }
    else {
        $id = @mysql_insert_id($conn);
        $rc = 0;
        writelog("insert for $user with id $id, size $size");
    }
    @mysql_close($conn);
    return $rc;
}

function find_decode_str($str, $encoding)
{
    $decode_str = decode_str($str);
    if (!is_utf8($decode_str))
        $decode_str = try_decode($decode_str, $encoding);
    if (!is_utf8($decode_str))
        $decode_str = try_decode($decode_str, $encoding, true);
    $decode_str = convert_code2utf8($decode_str);
    return $decode_str;
}

function decode_str($str)
{
    // base64
    if (preg_match("/=\?[0-9a-zA-Z\-]*\?[Bb]\?[0-9a-zA-Z+\/=]*\?=/", $str))
        $str = preg_replace_callback("|(=\?)([0-9a-zA-Z\-]*)(\?)([Bb])(\?)([0-9a-zA-Z+\/=]*)(\?=)|", 'my_decode', $str);
    // QP
    if (preg_match("/=\?[0-9a-zA-Z\-]*\?[Qq]\?[\x20-\x7F]*\?=/", $str))
        $str = preg_replace_callback("|(=\?)([0-9a-zA-Z\-]*)(\?)([Qq])(\?)([\x20-\x7F]*)(\?=)|", 'my_decode', $str);
    return $str;
}

function try_decode($str, $txt_encoding, $force = false)
{
    global $lang;

    $aEncoding[] = 'BIG5';
    $aEncoding[] = 'GB2312';
    $aEncoding[] = 'GBK';
    $aEncoding[] = 'SHIFT_JIS';
    $aEncoding[] = 'GB18030';

    if ($force)
        $force_trans = '//TRANSLATE';
    else
        $force_trans = '';

    if ($txt_encoding != '') {
        $utf8_str = @iconv($txt_encoding, ENCODING.$force_trans, $str);
        $test_str = @iconv(ENCODING, $txt_encoding, $utf8_str);
        if ($test_str == $str || $force)
            return $utf8_str;
    }
    foreach ($aEncoding as $x) {
        $utf8_str = @iconv($x, ENCODING.$force_trans, $str);
        $test_str = @iconv(ENCODING, $x, $utf8_str);
        if ($test_str == $str || $force)
            return $utf8_str;
    }
    return $str;
}

function my_decode($matches)
{
    //var_dump($matches);
    // $matches[0] => original string
    // $matches[1] => =? (begin)
    // $matches[2] => encoding
    // $matches[3] => ?
    // $matches[4] => B or Q
    // $matches[5] => ?
    // $matches[6] => encoded string
    // $matches[7] => ?= (end)
    $encoding = $matches[2];
    $type = $matches[4];
    $str = $matches[6];
    if ($type == 'B' || $type == 'b') {
        $decode_str = base64_decode($str);
        $utf8_str = @iconv($encoding, ENCODING, $decode_str);
        // if encoding is iso-8859-1, that's English, if should be same with UTF-8 string
        if (strcasecmp($encoding, 'iso-8859-1') == 0) {
            // if not match, try to decode it again.
            if ($utf8_str != $decode_str) {
                global $debug;

                if ($debug) writelog("maybe not iso-8859-1, try it later");
                return $decode_str;
            }
        }
        return $utf8_str;
    }
    $decode_str = preg_replace_callback("|(=)([0-9a-fA-F]{2})|", 'QP_decode', $str);
    return $decode_str;
}

function QP_decode($matches)
{
    //var_dump($matches);
    // $matches[0] => original string
    // $matches[1] => =
    // $matches[2] => hh
    return chr(hexdec($matches[2]));
}

function is_utf8($string)
{
   // From http://w3.org/International/questions/qa-forms-utf-8.html
   return preg_match('%^(?:
         [\x09\x0A\x0D\x20-\x7E]            # ASCII
       | [\xC2-\xDF][\x80-\xBF]            # non-overlong 2-byte
       |  \xE0[\xA0-\xBF][\x80-\xBF]        # excluding overlongs
       | [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
       |  \xED[\x80-\x9F][\x80-\xBF]        # excluding surrogates
       |  \xF0[\x90-\xBF][\x80-\xBF]{2}    # planes 1-3
       | [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
       |  \xF4[\x80-\x8F][\x80-\xBF]{2}    # plane 16
        )*$%xs', $string);
}

function convert_code2utf8($str)
{
    if (preg_match("/&#\d{4,7};/", $str)) {
        $x = preg_replace_callback(
            "|(&#)(\d{4,7})(;)|",
            "num2utf8",
            $str);
        $str = $x;
    }
    return $str;
}

function code2utf8($num)
{
    if ($num<128)
        return chr($num);
    if ($num<2048)
        return chr(($num>>6)+192).chr(($num&63)+128);
    if  ($num<65536)
        return chr(($num>>12)+224).chr((($num>>6)&63)+128).chr(($num&63)+128);
    if ($num<2097152)
        return chr(($num>>18)+240).chr((($num>>12)&63)+128).chr((($num>>6)&63)+128). chr(($num&63)+128);
    return '';
}

function num2utf8($matches)
{
    //var_dump($matches);
    // $matches[0] => original string
    // $matches[1] => &#
    // $matches[2] => nnnnn
    // $matches[3] => ;
    $code = $matches[2];
    return code2utf8($code);
}

?>
